import pandas as pd
import numpy as np
import pickle
import arviz as az
import matplotlib.pyplot as plt
import seaborn as sb
import japanize_matplotlib

pd.set_option('display.max_rows', 1000)
pd.set_option('display.max_columns', 1000)

"""
           Excelファイルからの読み込み
"""

in_file_name = 'Q2.xlsx'  
xlsx = pd.ExcelFile(in_file_name)
data_xlsx = pd.read_excel(xlsx)

y = data_xlsx.values.T[1]
print(y)
x = data_xlsx.values.T[2]
print(x)
n = len(y)

with open('temp.pkl', 'rb') as f:
    d_frm, i_data = pickle.load(f)

print(az.summary(i_data))

min_x = np.min(x)
max_x = np.max(x)
b0 = np.median(d_frm['b0'])
b1 = np.median(d_frm['b1'])
plt.plot([min_x, max_x], [b0 + b1*min_x, b0 + b1*max_x])
n = len(x)
pi = np.empty(n)
for i in range(n):
    pi[i] = np.median(d_frm[f'pi.{i+1}'])
plt.title(f'b0 = {b0:.3f},  b1 = {b1:.3f}', fontsize= 16)
for i in range(n):
    plt.plot(x[i], y[i], 'o', c = 'g' if pi[i] > 0.5 else 'r')
plt.plot([], 'o', c = 'g', label = 'pi>0.5')
plt.plot([], 'o', c = 'r', label = 'pi<=0.5')
plt.legend(loc = 'center', fontsize = 16)
plt.show()

az.plot_trace(i_data)
plt.show()

for i in range(n):
    pi_i = d_frm[f'pi.{i+1}']
    sb.kdeplot(pi_i)
plt.title('Posterior Distributions of pi', fontsize = 16)
plt.xlabel('pi', fontsize = 14)
plt.tight_layout()
plt.show()

with open('MixQ2b0b1.pkl', 'wb') as f:
    pickle.dump((d_frm['b0'], d_frm['b1']), f)

