functions {
    real mix_p_lpdf(real y, real pi, real mu, real sgm, real mu1, real sgm1 ) {
        real v;
        v = pi*exp(normal_lpdf(y|mu, sgm)) +
              (1.0 - pi)*exp(normal_lpdf(y|mu1, sgm1));
        return log(v);
    }
}
data {
    int n;
    vector[n] y;
    vector[n] x;
}
parameters {
    real b0;
    real b1;
    real<lower=0> sgm;
    vector[n] thetai;
}
transformed parameters {
    vector[n] pi;
    real mu1;
    real sgm1;
    pi = inv_logit(thetai);
    mu1 = -100.0;
    sgm1 = sgm;
}
model {
    thetai ~ normal(0.0, 10.0);
    b0 ~ normal(0, 10); 
    b1 ~ normal(0, 10);
    sgm ~ exponential(0.2);
    for (i in 1:n) {
        y[i] ~ mix_p(pi[i], b0+b1*x[i], sgm, mu1, sgm1);
    }
}
