import pandas as pd
import numpy as np
import stan
import pickle
import arviz as az

"""
           Excelファイルからの読み込み
"""
in_file_name = 'Q4.xlsx'   # input('入力データファイル(*.xlsx) = ')
xlsx = pd.ExcelFile(in_file_name)
data_xlsx = pd.read_excel(xlsx)

y = data_xlsx.values.T[1]
print(y)
x = data_xlsx.values.T[2]
print(x)
n = len(y)

with open('simple_reg.stan', 'r') as f:
    sm = stan.build(f.read(), data = {'n':n, 'y':y, 'x':x})
fit = sm.sample()

d_frm = fit.to_frame()
i_data = az.from_pystan(posterior = fit, posterior_model = sm)

with open('temp.pkl', 'wb') as f:
    pickle.dump((d_frm, i_data), f)

print(az.summary(i_data))

